Program XMS_Using;

Uses CRT, XMS;

Var
  Desc : Word;
  MRec : XMMRec;

Begin
  ClrScr;

  If XMSInstalled = 0 then
    Begin
      WriteLn ('Your computer has no extended memory!'#13#10);
      Exit
    End
  Else
    WriteLn ('Extended memory installed : ',XMSInstalled,' KB'#13#10);

  If HimemInstalled then
    WriteLn ('HIMEM.SYS is installed.'#13#10)
  Else
    Begin
      WriteLn ('HIMEM.SYS is not installed!'#13#10);
      Exit
    End;

  Write ('Line A20 state            : ');
  If ActiveA20 then WriteLn ('Active'#13#10)
  Else WriteLn ('Not active'#13#10);

  Write ('HMA                       : ');
  If HMAAvaible then WriteLn ('Present'#13#10)
  Else WriteLn ('No'#13#10);

  WriteLn ('UMB free                  : ',UMBFree div 64, ' KB'#13#10);

  WriteLn ('XMS free                  : ',XMSFree,' KB');
  WriteLn ('Largest free block in XMS : ',XMSLargest,' KB');

  If XMSLargest < 4 then
    Begin
      WriteLn (#13#10'Can not allocate 4 KB in XMS!'#13#10);
      Exit
    End;

  ReadLn;                               { wait for Enter }

  GetXMS (Desc, 4);                     { allocate 4 KB from XMS-memory }

  MRec.Size := 4000;                    { even size for copy block }
  MRec.DSource := 0;                    { source descriptor - conventional memory }
  MRec.OSource := Ptr ($B800,0);        { source address - screen }
  MRec.DDest := Desc;                   { destination descriptor }
  LongInt(MRec.ODest) := 0;             { offset in distination area }
  MoveXMS (MRec);                       { copying done }

  FillChar (Mem[$B800:0], 4000, 0);     { clear screen }

  ReadLn;                               { wait for Enter }

  MRec.Size := 4000;
  MRec.DSource := Desc;
  LongInt(MRec.OSource) := 0;           { Offset = zero; also avaible: MRec.OSource := Nil }
  MRec.DDest := 0;
  MRec.ODest := Ptr ($B800,0);
  MoveXMS (MRec);                       { back copying from XMS to screen }

  FreeXMS (Desc)                        { deallocate 4 KB XMS-memory }
End.
